/*
 * Copyright (c) 2021, Mediatek Inc. All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

#ifndef APUSYS_SECURE_BOOT_H
#define APUSYS_SECURE_BOOT_H

#include <platform_def.h>

/* 
    RSA2048 public key for verifying apusys image
*/
#define APUSYS_IMG_VFY_PUBK_SZ 256
#define RSA_LEN 256

#define APUSYS_IMG_VFY_PUBK_M \
    0xc3, 0x3c, 0xef, 0x63, 0x99, 0x35, 0x38, 0x84, \
    0x42, 0x15, 0x15, 0x01, 0x12, 0x79, 0xa3, 0xe1, \
    0x0c, 0xfa, 0xf6, 0xed, 0xad, 0x1b, 0xb0, 0x88, \
    0xb9, 0xe9, 0x4a, 0x1c, 0x34, 0x25, 0x84, 0x33, \
    0x22, 0x7b, 0x97, 0x44, 0x0b, 0xf3, 0xd6, 0xd3, \
    0x1e, 0xfa, 0x0d, 0x78, 0x62, 0x8c, 0xcc, 0xde, \
    0xc6, 0x2b, 0x6b, 0xd9, 0x53, 0xe4, 0xcd, 0xeb, \
    0x9f, 0xfe, 0xbf, 0xcf, 0x1e, 0x25, 0x54, 0x53, \
    0x71, 0x40, 0xb9, 0xfd, 0xad, 0xab, 0x6c, 0xd9, \
    0xb6, 0x38, 0xc0, 0x6e, 0x25, 0x7f, 0xee, 0x90, \
    0x18, 0xb4, 0x25, 0x0b, 0x1f, 0xdb, 0x37, 0x51, \
    0xd1, 0x3a, 0x43, 0x75, 0xb6, 0x93, 0xc2, 0xa1, \
    0x67, 0xea, 0xe3, 0x56, 0x34, 0xdf, 0x42, 0xb9, \
    0x43, 0x2b, 0xb5, 0x0f, 0x80, 0x1b, 0x55, 0xca, \
    0x1e, 0x4f, 0xdd, 0x58, 0x86, 0x2c, 0xd8, 0x65, \
    0xa8, 0x2c, 0x2f, 0x04, 0xe4, 0x68, 0xaf, 0xa5, \
    0x1e, 0x53, 0x48, 0x5c, 0xa6, 0xaf, 0x74, 0xec, \
    0x88, 0x43, 0x65, 0x41, 0xcf, 0xfc, 0xb6, 0xf2, \
    0x52, 0xc9, 0x46, 0x03, 0xb5, 0xb6, 0x0e, 0xc5, \
    0x07, 0xcc, 0x79, 0x45, 0xe1, 0x5c, 0x7c, 0x48, \
    0x08, 0x85, 0xf5, 0x8e, 0x85, 0x04, 0xb9, 0x6f, \
    0x76, 0x3a, 0x22, 0x8f, 0xd3, 0x7e, 0x1e, 0xce, \
    0xcf, 0xe4, 0x7b, 0x2b, 0x33, 0x49, 0x25, 0xa0, \
    0x37, 0x7b, 0x6b, 0x5e, 0xba, 0xb3, 0x49, 0x67, \
    0x7d, 0xa1, 0xba, 0x02, 0xa3, 0x5b, 0xc5, 0xe1, \
    0x9b, 0x0a, 0x6d, 0x83, 0xdb, 0x71, 0xfb, 0xe0, \
    0xc4, 0x28, 0xe7, 0x6d, 0x0b, 0xe5, 0x99, 0x40, \
    0x17, 0x79, 0xb0, 0x0c, 0xe7, 0xfb, 0xb3, 0x36, \
    0xe5, 0xba, 0x0d, 0xd2, 0x81, 0xcd, 0x95, 0x68, \
    0x2b, 0x64, 0x86, 0xd6, 0xd1, 0x66, 0x0c, 0x02, \
    0xa1, 0x3b, 0xae, 0x42, 0x9e, 0xad, 0x60, 0x0e, \
    0xd0, 0xc5, 0x3a, 0x79, 0x3c, 0xee, 0xb6, 0x33

#define APUSYS_IMG_VFY_PUBK_RR \
    0x3e, 0xb8, 0xa6, 0xf6, 0x95, 0xc1, 0x21, 0xfb, \
    0xd8, 0xca, 0x63, 0x96, 0x6b, 0xc1, 0xde, 0x56, \
    0xde, 0xa6, 0xb8, 0xa6, 0xc8, 0x19, 0x70, 0x7d, \
    0xed, 0x46, 0xa7, 0x49, 0xc8, 0xf8, 0xea, 0xff, \
    0x1a, 0x16, 0x89, 0x1f, 0xfb, 0x1f, 0x91, 0xcc, \
    0x87, 0x0e, 0xdc, 0x29, 0x52, 0x14, 0xd5, 0x5d, \
    0xe9, 0xff, 0xfd, 0x05, 0xbd, 0xdd, 0xfb, 0x47, \
    0x6d, 0x5c, 0x2b, 0xbe, 0xf3, 0x70, 0xa5, 0x7c, \
    0x59, 0xf8, 0xfe, 0xad, 0xeb, 0xd7, 0x2f, 0xb0, \
    0xa5, 0x98, 0xa5, 0x0e, 0x7e, 0x68, 0xf0, 0x6f, \
    0x1d, 0x0f, 0x96, 0x35, 0x20, 0x07, 0x58, 0x7d, \
    0xf4, 0x11, 0xc9, 0x68, 0x54, 0x7f, 0x0d, 0x2c, \
    0x0c, 0xee, 0xb5, 0x92, 0x9e, 0xed, 0xec, 0x0a, \
    0x9f, 0x79, 0xf1, 0x45, 0xf2, 0x75, 0xad, 0x74, \
    0x7b, 0xe1, 0xe6, 0xa2, 0xf0, 0xce, 0x95, 0xef, \
    0x32, 0xe5, 0x29, 0x29, 0xc1, 0x34, 0x6e, 0xab, \
    0x6f, 0x61, 0x56, 0xa3, 0xd9, 0x57, 0x1d, 0xe4, \
    0x06, 0x76, 0x8d, 0x39, 0x90, 0x94, 0x2b, 0xaa, \
    0x40, 0x65, 0x9b, 0x6c, 0x47, 0x07, 0xdb, 0xd7, \
    0xb8, 0x6f, 0x60, 0x6d, 0xeb, 0x00, 0x6e, 0xae, \
    0xcf, 0x10, 0xcd, 0x38, 0x49, 0x7a, 0x82, 0xd4, \
    0x8f, 0xb3, 0xd3, 0x22, 0xda, 0xd3, 0xca, 0x53, \
    0xb3, 0x4b, 0x1d, 0x53, 0x57, 0x2e, 0xda, 0xbd, \
    0xc6, 0x7e, 0x32, 0x0b, 0xac, 0x87, 0xdb, 0xeb, \
    0x0b, 0x92, 0x4f, 0x4a, 0xd2, 0xca, 0xfc, 0x60, \
    0x72, 0x9f, 0x65, 0xa0, 0x52, 0x0e, 0x5c, 0xf4, \
    0xed, 0xd6, 0x8b, 0x88, 0x01, 0xe7, 0xa3, 0xe6, \
    0xac, 0x92, 0xb9, 0x46, 0x1c, 0x86, 0x06, 0x29, \
    0x50, 0x1e, 0x81, 0x4b, 0xdd, 0x6c, 0x16, 0x39, \
    0x08, 0x67, 0x7e, 0x05, 0x99, 0xc1, 0x60, 0xf0, \
    0x05, 0x15, 0x83, 0x83, 0x89, 0x47, 0x0e, 0x70, \
    0xc7, 0x0e, 0x0e, 0x30, 0x28, 0x41, 0x33, 0xdc

int apusys_image_verify(uint64_t* addr, uint32_t size, char* sig);

#endif